<template>
    <div class="order-request-execution">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Изменить"
        :is-loading="isLoading"
        data-qa="ChangePvpForm"
        @submit="onSubmitHandler"
      >
        <div class="title">Укажите новую дату и время ПВП</div>
        <div class="row row-inputs">
          <div class="col-xs-6">
            <ObDatePicker
              v-model="order.pvpDt"
              label="Текущее ПВП"
              :is-time="true"
              :readonly="true"
              data-qa="datetime"
            />
          </div>
          <div class="col-xs-6">
            <ObDatePicker
              v-model="formData.pvp"
              label="Новое ПВП"
              :is-time="true"
              data-qa="datetime"
            />
          </div>
        </div>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          :upload-method="uploadMethod"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'
import moment from 'moment'

export default {
  name: 'ChangePvpModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObDatePicker,
    ObUploader
  },
  props: {
    order: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    ...mapGetters({}),
    formModel () {
      return {
        fileUuid: {
          value: ''
        },
        pvp: {
          value: '',
          validator: {
            required
          }
        },
      }
    },
    uploadMethod () {
      return api.files.postFile
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.fileUuid = null
        return
      }

      this.formData.fileUuid = data.uuid
    },
    async afterInitForm () {
      this.formData.pvp = moment(this.order.pvpDt).diff(moment()) < 1 ? moment().add(3, 'hours') : moment(this.order.pvpDt).add(1, 'hours')
    },
    async onSubmitHandler (data) {
      try {
        this.isLoading = true
        await api.orderProcess.changePvpDate({ uuid: this.order.uuid, ...data })
        this.isLoading = false
        this.$emit('on-submited')
      } catch (e) {
        this.isLoading = false
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка сохранения даты ПВП'
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
</style>
